unit UnidadUtilidadesBD;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ComCtrls;

type
  TformUtilidadesBD = class(TForm)
    tab: TPageControl;
    tabSQLCreacion: TTabSheet;
    tabOptimizar: TTabSheet;
    bCerrar: TBitBtn;
    bObtenerScript: TBitBtn;
    mScripCreacion: TRichEdit;
    bObtenerNombreTablas: TBitBtn;
    bGuardarRScript: TBitBtn;
    dlGuardar: TSaveDialog;
    bVariables: TBitBtn;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    mResultadoOptimizar: TMemo;
    bOptimizar: TBitBtn;
    tabAnalizar: TTabSheet;
    BitBtn4: TBitBtn;
    mResultadoAnalizar: TMemo;
    bCatalogos: TBitBtn;
    TabSheet1: TTabSheet;
    bMostrarTablas: TBitBtn;
    opReiniciarContador: TCheckBox;
    bEliminarContenido: TBitBtn;
    StaticText1: TStaticText;
    lsTablas: TListBox;
    Label1: TLabel;
    TabSheet2: TTabSheet;
    bCambiarTipo: TBitBtn;
    bMostrarTablas2: TBitBtn;
    lsTablas2: TListBox;
    Label2: TLabel;
    lsTipoBD: TComboBox;
    Label3: TLabel;
    bpTipo: TProgressBar;
    procedure bObtenerScriptClick(Sender: TObject);
    procedure bObtenerNombreTablasClick(Sender: TObject);
    procedure bGuardarRScriptClick(Sender: TObject);
    procedure bVariablesClick(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure bCatalogosClick(Sender: TObject);
    procedure bOptimizarClick(Sender: TObject);
    procedure bCerrarClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure bEliminarContenidoClick(Sender: TObject);
    procedure bMostrarTablasClick(Sender: TObject);
    procedure bMostrarTablas2Click(Sender: TObject);
    procedure bCambiarTipoClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formUtilidadesBD: TformUtilidadesBD;

implementation

uses UnidadModuloDatos, DB;

{$R *.dfm}

procedure TformUtilidadesBD.bObtenerScriptClick(Sender: TObject);
begin
  mScripCreacion.Lines.Clear;
  md.tc2.Close;
  md.tc2.SQL.Clear;
  md.tc2.SQL.Add('show tables');
  md.tc2.Open;
  while not md.tc2.Eof do
  begin
    md.tc.Close;
    md.tc.SQL.Clear;
    md.tc.SQL.Add('show create table ' + md.tc2.Fields.Fields[0].AsString);
    md.tc.Open;
    mScripCreacion.Lines.Add('');
    mScripCreacion.Lines.Add('');    
    mScripCreacion.Lines.Add(md.tc.Fields.Fields[1].AsString);
    md.tc2.Next;
  end;
  md.tc2.close;
  md.tc.Close;
end;

procedure TformUtilidadesBD.bObtenerNombreTablasClick(Sender: TObject);
begin
  mScripCreacion.Lines.Clear;
  md.tc2.Close;
  md.tc2.SQL.Clear;
  md.tc2.SQL.Add('show tables');
  md.tc2.Open;
  while not md.tc2.Eof do
  begin
    mScripCreacion.Lines.Add(md.tc2.Fields.Fields[0].AsString);
    md.tc2.Next;
  end;
  md.tc2.close;
end;

procedure TformUtilidadesBD.bGuardarRScriptClick(Sender: TObject);
begin
  dlGuardar.Title := 'Guardar resultado Script/Tablas';
  dlGuardar.Filter := 'Archivo de texto (*.txt)|*.txt|Script SQL (*.sql)|*.sql|Todos los archivos|*.*';
  dlGuardar.DefaultExt := 'txt';
  if dlGuardar.Execute then
    mScripCreacion.Lines.SaveToFile(dlGuardar.FileName);
end;

procedure TformUtilidadesBD.bVariablesClick(Sender: TObject);
begin
  mScripCreacion.Lines.Clear;
  md.tc2.Close;
  md.tc2.SQL.Clear;
  md.tc2.SQL.Add('show variables');
  md.tc2.Open;
  while not md.tc2.Eof do
  begin
    mScripCreacion.Lines.Add(md.tc2.Fields.Fields[0].AsString + ' = ' + md.tc2.Fields.Fields[1].AsString);
    md.tc2.Next;
  end;
  md.tc2.close;
end;

procedure TformUtilidadesBD.BitBtn1Click(Sender: TObject);
var
 campo, tipo, nulo, clave, defecto, extra : string;
begin
  mScripCreacion.Lines.Clear;
  md.tc2.Close;
  md.tc2.SQL.Clear;
  md.tc2.SQL.Add('show tables');
  md.tc2.Open;
  while not md.tc2.Eof do
  begin
    md.tc.Close;
    md.tc.SQL.Clear;
    md.tc.SQL.Add('desc ' + md.tc2.Fields.Fields[0].AsString);
    md.tc.Open;
    mScripCreacion.Lines.Add('');
    mScripCreacion.Lines.Add('');
    mScripCreacion.Lines.Add(md.tc2.Fields.Fields[0].AsString);
    while not md.tc.Eof do
    begin
      campo := md.tc.fieldbyname('field').AsString;
      tipo := md.tc.fieldbyname('type').AsString;
      nulo := md.tc.fieldbyname('null').AsString;
      clave := md.tc.fieldbyname('key').AsString;
      defecto := md.tc.fieldbyname('default').AsString;
      extra := md.tc.fieldbyname('extra').AsString;
      mScripCreacion.Lines.Add('[' + campo + ']' + '  [' + tipo + ']  ' +
          '[' + nulo + ']  ' + '[' + clave + ']  ' + '[' + defecto + ']  ' +
          '[' + extra + ']');
      md.tc.Next;
    end;
    md.tc2.Next;
  end;
  md.tc2.close;
  md.tc.Close;
end;

procedure TformUtilidadesBD.BitBtn2Click(Sender: TObject);
var
  nombre, engine, fechacreacion, collation : string;
  tamano, rows, tamanoIndice, tamanoTotal, tamanoTotalIndice, rowsTotales : Double;
begin
  mScripCreacion.Lines.Clear;
  tamanoTotal := 0;
  rowsTotales := 0;
  tamanoTotalIndice := 0;
  md.tc.Close;
  md.tc.SQL.Clear;
  md.tc.SQL.Add('show table status');
  md.tc.Open;
  mScripCreacion.Lines.Add('');
  mScripCreacion.Lines.Add('');
  while not md.tc.Eof do
  begin
    nombre := md.tc.fieldbyname('name').AsString;
    engine := md.tc.fieldbyname('engine').AsString;
    rows := md.tc.fieldbyname('rows').AsFloat;
    rowsTotales := rowsTotales + rows;
    tamano := md.tc.fieldbyname('data_length').AsFloat;
    tamanoTotal := tamanoTotal + tamano;
    tamanoIndice := md.tc.fieldbyname('index_length').AsFloat;
    tamanoTotalIndice := tamanoTotalIndice + tamanoIndice;
    fechacreacion := md.tc.fieldbyname('create_time').AsString;
    collation := md.tc.fieldbyname('collation').AsString;
    mScripCreacion.Lines.Add('[' + nombre + ']' + '  [' + engine + ']  ' +
        '[' + FloatToStr (rows) + ']  ' + '[' + FloatToStr(tamano) + ']  ' +
        '[' + FloatToStr (tamanoIndice) + ']  ' + '[' + fechacreacion + ']' +
        '[' + collation + ']');
    md.tc.Next;
  end;
  mScripCreacion.Lines.Add('');
  mScripCreacion.Lines.Add('');
  mScripCreacion.Lines.Add('');
  mScripCreacion.Lines.Add('------------ TOTALES -----------');
  mScripCreacion.Lines.Add('Tamao total datos: ' + FloatToStr(tamanoTotal));
  mScripCreacion.Lines.Add('Tamao total ndices: ' + FloatToStr(tamanoTotalIndice));
  mScripCreacion.Lines.Add('Filas totales: ' + FloatToStr(rowsTotales));
  md.tc.Close;
end;

procedure TformUtilidadesBD.BitBtn3Click(Sender: TObject);
begin
  mScripCreacion.Lines.Clear;
  md.tc2.Close;
  md.tc2.SQL.Clear;
  md.tc2.SQL.Add('show status');
  md.tc2.Open;
  while not md.tc2.Eof do
  begin
    mScripCreacion.Lines.Add(md.tc2.Fields.Fields[0].AsString + ' = ' + md.tc2.Fields.Fields[1].AsString);
    md.tc2.Next;
  end;
  md.tc2.close;
end;

procedure TformUtilidadesBD.FormShow(Sender: TObject);
begin
  tabSQLCreacion.Show;
end;

procedure TformUtilidadesBD.BitBtn4Click(Sender: TObject);
begin
  mResultadoAnalizar.Lines.Clear;
  md.tc2.Close;
  md.tc2.SQL.Clear;
  md.tc2.SQL.Add('show tables');
  md.tc2.Open;
  while not md.tc2.Eof do
  begin
    md.tc.Close;
    md.tc.SQL.Clear;
    md.tc.SQL.Add('analyze table ' + md.tc2.Fields.Fields[0].AsString);
    md.tc.Open;
    mResultadoAnalizar.Lines.Add(md.tc.Fields.Fields[0].AsString + ' ' +
        md.tc.Fields.Fields[2].AsString + ' ' + md.tc.Fields.Fields[3].AsString);
    md.tc2.Next;
  end;
  md.tc2.close;
  md.tc.Close;
end;

procedure TformUtilidadesBD.bCatalogosClick(Sender: TObject);
begin
  mScripCreacion.Lines.Clear;
  md.tc2.Close;
  md.tc2.SQL.Clear;
  md.tc2.SQL.Add('show databases');
  md.tc2.Open;
  while not md.tc2.Eof do
  begin
    mScripCreacion.Lines.Add(md.tc2.Fields.Fields[0].AsString);
    md.tc2.Next;
  end;
  md.tc2.close;
end;

procedure TformUtilidadesBD.bOptimizarClick(Sender: TObject);
begin
  mResultadoOptimizar.Lines.Clear;
  md.tc2.Close;
  md.tc2.SQL.Clear;
  md.tc2.SQL.Add('show tables');
  md.tc2.Open;
  while not md.tc2.Eof do
  begin
    md.tc.Close;
    md.tc.SQL.Clear;
    md.tc.SQL.Add('optimize table ' + md.tc2.Fields.Fields[0].AsString);
    md.tc.Open;
    mResultadoOptimizar.Lines.Add(md.tc.Fields.Fields[0].AsString + ' ' +
        md.tc.Fields.Fields[2].AsString + ' ' + md.tc.Fields.Fields[3].AsString);
    md.tc2.Next;
  end;
  md.tc2.close;
  md.tc.Close;
end;

procedure TformUtilidadesBD.bCerrarClick(Sender: TObject);
begin
  close;
end;

procedure TformUtilidadesBD.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TformUtilidadesBD.bEliminarContenidoClick(Sender: TObject);
var
  i : integer;
  nombreTablasEliminar : string;
begin
  if MessageDlg('Est seguro que desea eliminar el contenido de ' +
      inttostr(lsTablas.SelCount) + ' tablas?',
      mtConfirmation, [mbno, mbyes], 0) = mryes then
  begin
    for i := 0 to lsTablas.Count - 1 do
    begin
      if lsTablas.Selected[i] then
        if nombreTablasEliminar = '' then
          nombreTablasEliminar := lsTablas.Items[i]
        else
          nombreTablasEliminar := nombreTablasEliminar + ', ' +
              lsTablas.Items[i];
    end;
    if MessageDlg('Se va a eliminar el contenido de ' +
        'las siguientes tablas: ' +
        nombreTablasEliminar + '.' + chr(13) + chr(13) +
        '  Pulse "No" para continuar. ' + chr(13) +
        '  Pulse "S" para anular el proceso.', mtConfirmation,
        [mbyes, mbno], 0) = mrno then
    begin
      for i := 0 to lsTablas.Count - 1 do
      begin
        if lsTablas.Selected[i] then
        begin
          md.tc2.Close;
          md.tc2.SQL.Clear;
          md.tc2.SQL.Add('truncate table ' + lsTablas.Items[i]);
          md.tc2.ExecSQL;
          md.tc2.close;
          if opReiniciarContador.Checked then
          begin
            md.tc2.Close;
            md.tc2.SQL.Clear;
            md.tc2.SQL.Add('ALTER TABLE ' + lsTablas.Items[i] +
                ' AUTO_INCREMENT = 1;');
            md.tc2.ExecSQL;
            md.tc2.close;
          end;
        end;
      end;
      MessageDlg('Se ha eliminado el contenido de las ' +
          'tablas seleccionadas correctamente.',
          mtInformation, [mbok], 0);
    end;
  end;
end;

procedure TformUtilidadesBD.bMostrarTablasClick(Sender: TObject);
begin
  lsTablas.Clear;
  md.tc2.Close;
  md.tc2.SQL.Clear;
  md.tc2.SQL.Add('show tables');
  md.tc2.Open;
  while not md.tc2.Eof do
  begin
    lsTablas.Items.Add(md.tc2.Fields.Fields[0].AsString);
    md.tc2.Next;
  end;
  md.tc2.close;
end;

procedure TformUtilidadesBD.bMostrarTablas2Click(Sender: TObject);
begin
  lsTablas2.Clear;
  md.tc2.Close;
  md.tc2.SQL.Clear;
  md.tc2.SQL.Add('show tables');
  md.tc2.Open;
  while not md.tc2.Eof do
  begin
    lsTablas2.Items.Add(md.tc2.Fields.Fields[0].AsString);
    md.tc2.Next;
  end;
  md.tc2.close;
end;

procedure TformUtilidadesBD.bCambiarTipoClick(Sender: TObject);
var
  i, numTablas : integer;
  nombreTablasCambiar, tipoTabla : string;
begin
  bpTipo.Position := 0;
  bpTipo.Min := 0;
  tipoTabla := lsTipoBD.Text;
  if tipoTabla = '' then
  begin
    MessageDlg ('Debe indicar el nuevo tipo de tabla.', mtInformation, [mbok], 0);
    lsTipoBD.SetFocus;
  end
  else
  begin
    if MessageDlg('Est seguro que desea cambiar el tipo de ' +
        inttostr(lsTablas2.SelCount) + ' tablas?',
        mtConfirmation, [mbno, mbyes], 0) = mryes then
    begin
      numTablas := lsTablas2.Count;
      for i := 0 to numTablas - 1 do
      begin
        if lsTablas2.Selected[i] then
          if nombreTablasCambiar = '' then
            nombreTablasCambiar := lsTablas2.Items[i]
          else
            nombreTablasCambiar := nombreTablasCambiar + ', ' +
                lsTablas2.Items[i];
      end;
      if MessageDlg('Se va a cambiar el tipo de las siguientes tablas: ' +
          nombreTablasCambiar + '.' + chr(13) + chr(13) +
          '  Pulse "No" para continuar. ' + chr(13) +
          '  Pulse "S" para anular el proceso.', mtConfirmation,
          [mbyes, mbno], 0) = mrno then
      begin
        bpTipo.Max := lsTablas2.SelCount - 1;
        for i := 0 to numTablas - 1 do
        begin
          bpTipo.Position := i;        
          if lsTablas2.Selected[i] then
          begin
            md.tc2.Close;
            md.tc2.SQL.Clear;
            md.tc2.SQL.Add('ALTER TABLE ' + lsTablas2.Items[i] + ' ENGINE = ' + tipoTabla);
            //md.tc2.SQL.Add('ALTER TABLE :pNombreTabla ENGINE = ' + tipoTabla);
            //md.tc2.ParamByName('pNombreTabla').DataType := ftString;
            //md.tc2.ParamByName('pNombreTabla').AsString := lsTablas2.Items[i];
            md.tc2.ExecSQL;
            md.tc2.close;
          end;
        end;
        MessageDlg('El proceso ha finalizado correctamente.',
            mtInformation, [mbok], 0);
      end;
    end;
  end;
end;

end.
